#импортируем требуемые для анализа библиотеки из предустановленного пакета biopython
import pandas as pd
from Bio import SeqIO, AlignIO
from Bio.Seq import Seq
import warnings
warnings.filterwarnings("ignore")
import os
#открываем выравненную последовательность и вычисляем количество сиквенсов
alignment = AlignIO.read("alignment.fa", "fasta")
num = len([1 for line in open("alignment.fa") if line.startswith(">")])
#открываем референсную последовательность
record = SeqIO.read("reference.fa", "fasta")
s = list(record.seq)
rows = []
#делаем таблицу сиквенса референса и конкретной пробы, обозначаем делеции и вставки
for j in range(1, num):
    rows_list = []
    for i in range(0, len(alignment[0])):
        dict1 = {'REF': alignment[0][i], 'POS': i, 'ALT': alignment[j][i]} if alignment[j][i] != alignment[0][i] else {'REF': alignment[0][i], 'POS': i, 'ALT': alignment[0][i]}
        rows_list.append(dict1)
    df0 = pd.DataFrame(rows_list) 
    df0.ALT = df0.ALT.replace('-', 'del')
    df0.REF = df0.REF.replace('-', 'ins')
    k = 0
    ins = 0
    #Ищем мутации, сдвигая нумерацию позиций, если они найдены
    for ii in range(0, df0.ALT.count()): 
        if df0.ALT.iloc[ii]=="del": k+=1
        if df0.REF.iloc[ii] == "ins": 
            df0.POS.iloc[ii] = df0.POS.iloc[ii] - k+2
            ins+=1
        if (df0.ALT.iloc[ii] != "del"): df0.POS.iloc[ii] = df0.POS.iloc[ii] - ins+1
    #Оставляем делеции для поиска выпавших аминокислот
    dd1 = df0[df0.ALT == 'del']
    #Ищем делеции в Spike белке (позиции в геноме 21563:25384)
    dd2 = dd1[(dd1.POS>=21562) & (dd1.POS<=25383)]
    delt = []
    delt = (dd2.POS-21562)/3
    #delt2 = [int(x) for x in delt]
    #delt = delt[delt % delt2 == 0]
    delt = [int(x) for x in delt]
    delt = list(set(delt))    
    delt = sorted(delt) #позиция выпавшей аминокислоты в геноме
    df0 = df0.drop(df0[df0.ALT == 'del'].index)
    df0 = df0.drop(df0[df0.REF == 'ins'].index)
    df0 = df0.dropna()
    #Открываем "подставной" референс, который будет равен мутировавшему штамму и сравнен с неизмененным референсом
    probe = list(alignment[0].seq)
    for i in range(0, len(df0)): 
        if (df0.POS.iloc[i]-1)<len(probe): probe[df0.POS.iloc[i]-1] = df0.ALT.iloc[i] #подставляем мутации в "референс"
    spike1 = s[21562:25383]
    spike1 = ''.join(spike1) #переводим последовательность Spike гена в строчный вид для настоящего референса
    spike2 = probe[21562:25383]
    spike2 = ''.join(spike2) #переводим последовательность Spike гена в строчный вид для подставного референса
    translation = Seq(spike1).translate()
    delet = []
    #складываем в массив делеции в аминокислотах
    for n in delt: 
        delet.append(str(str(translation[n]) + str(n+1) + 'del'))
    #функция, создающая таблицу транслированных последовательностей пробы и референса, и выводящая замены
    def trans(seq,probe):
        trans1 = Seq(seq).translate()
        trans2 = Seq(probe).translate()
        data_tuples = list(zip(trans1, trans2))
        dff = pd.DataFrame(data_tuples, columns=['Ref','Probe'])
        arr = []
        new_df = dff[dff['Ref'] != dff['Probe']]
        new_df['index'] = new_df.index
        new_df['index'].loc[::]+=1
        new_df = new_df.drop(new_df[new_df.Probe == 'X'].index)
        df = new_df[['Ref','index','Probe']]
        if (df.empty): reps = ''
        else:
            x = df.to_string(header=False, index=False, index_names=False).split('\n')
            reps = [''.join(ele.split()) for ele in x]
            arr.append(reps) 
        return arr
    sp = str(delet) + ' ' + str(trans(spike1,spike2)) #строка с выводом всех делеций и замен в анализируемой пробе
    chars = ["[","]","'"]
    for c in chars: sp = sp.replace(c, "")
    #Создание табличного вида: Проба-Мутации
    dd = pd.DataFrame({'Sample name': [alignment[j].name], 
           'Spike':  [sp], 
           'Alpha (B.1.1.7)': ['-'],
           'Beta (B.1.351)': ['-'],
           'Gamma (P.1)': ['-'],
           'Delta (B.1.617.2)':['-'],
           'Kappa (B.1.617.1)':['-'],      
           })
    rows.append(dd)
    result = pd.concat(rows, ignore_index=True)
#список мутаций
brit = ['H69del', 'V70del', 'Y144del', 'N501Y', 'A570D', 'D614G', 'P681H', 'T716I', 'S982A', 'D1118H']
uar = ['D80A', 'E484K', 'N501Y']
brazil = ['L18F', 'T20N', 'P26S', 'D138Y', 'R190S', 'K417T', 'E484K', 'N501Y', 'D614G', 'H655Y', 'T1027I']
india1 = ['T19R', 'E156del', 'F157del', 'R158G', 'L452R', 'T478K', 'D614G', 'P681R', 'D950N']
india2 = ['G142D', 'E154K', 'L452R', 'E484Q', 'D614G', 'P681R', 'Q1071H']
#построчная проверка мутаций в пробах на соответствие известным генотипам
for i in range(0, len(result)):
    if all(x in result.Spike.loc[i] for x in brit): result['Alpha (B.1.1.7)'][i] = 'Да'
    if all(x in result.Spike.loc[i] for x in uar): result['Beta (B.1.351)'][i] = 'Да'
    if all(x in result.Spike.loc[i] for x in brazil): result['Gamma (P.1)'][i] = 'Да'
    if all(x in result.Spike.loc[i] for x in india1): result['Delta (B.1.617.2)'][i] = 'Да'
    if all(x in result.Spike.loc[i] for x in india2): result['Kappa (B.1.617.1)'][i] = 'Да'
#запись результата анализа в табличный файл    
result.to_csv('result.csv')
#os.remove('alignment.fa')